package com.orbbec.obviewer2;

import android.Manifest;
import android.content.pm.PackageManager;
import android.graphics.PixelFormat;
import android.opengl.GLSurfaceView;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.widget.CheckBox;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;

import com.orbbec.astra.Vector2D;
import com.orbbec.obviewer2.callback.ViewCallBack;
import com.orbbec.obviewer2.listener.CheckBoxCheckChangeListenter;
import com.orbbec.obviewer2.model.OBSourceInterface;
import com.orbbec.obviewer2.present.ObViewWallPresentImp;
import com.orbbec.obviewer2.present.OpenInterface;
import com.orbbec.obviewer2.util.FPSMeter;
import com.orbbec.obviewer2.util.NativeUtils;
import com.orbbec.obviewer2.util.Utils;
import com.orbbec.obviewer2.view.GlBodyRenderer;
import com.orbbec.obviewer2.view.GlBodyView;
import com.orbbec.obviewer2.view.MyRender;
import com.orbbec.obviewer2.view.OpenGLMaskColorView;
import com.orbbec.obviewer2.view.OpenGlColorView;
import com.orbbec.obviewer2.view.OpenGlColorizedBodyView;
import com.orbbec.obviewer2.view.OpenGlDepthView;

import java.lang.ref.WeakReference;
import java.nio.ByteBuffer;
import java.nio.IntBuffer;
import java.nio.ShortBuffer;

import static android.os.Build.VERSION_CODES.M;
import static android.view.View.SYSTEM_UI_FLAG_IMMERSIVE;

public class MainActivity_copy extends AppCompatActivity implements ViewCallBack {

    public static final String TAG = "lgp";

    private OpenGlColorView mColorView;
    private OpenGlDepthView mDepthView;
    private OpenGLMaskColorView mMaskedColorView;
    private OpenGlColorizedBodyView mColorizedBodyView;
    private GlBodyView mGLBodyView;
    private GlBodyRenderer mGLBodyRenderer;

    private CheckBox mCheckColorBox;
    private CheckBox mCheckDepthBox;
    private CheckBox mCheckMaskedColorBox;
    private CheckBox mCheckColorizedBodyBox;
    private CheckBox mCheckSkeletonBox;
    private CheckBox mCheckColorMirroredBox;
    private ToggleButton mToggleDepthRes;
    private CheckBox mCheckIsShowBox;

    private TextView mTxtRunTime;
    private TextView mTxtCPUTotal;
    private TextView mTxtCPUCurrent;
    private TextView mTxtCPUAverage;
    private TextView mTxtCPUMinimum;
    private TextView mTxtCPUHighest;
    private TextView mTxtRAMCurrent;
    private TextView mTxtRAMAverage;
    private TextView mTxtRAMMinimum;
    private TextView mTxtRAMHighest;
    private TextView mTxtUpdateDataCurrent;
    private TextView mTxtUpdateDataAverage;
    private TextView mTxtUpdateDataMinimum;
    private TextView mTxtUpdateDataHighest;
    private TextView mTxtBKUpdateDataCurrent;
    private TextView mTxtBKUpdateDataAverage;
    private TextView mTxtBKUpdateDataMinimum;
    private TextView mTxtBKUpdateDataHighest;
    private TextView mTxtFRCurrent;
    private TextView mTxtFRAverage;
    private TextView mTxtFRMinimum;
    private TextView mTxtFRHighest;

    private TextView mTxt1;
    private TextView mTxt2;
    private TextView mTxt3;
    private TextView mTxt4;
    private TextView mTxt5;

//    private Button mSaveButton;


    private int mColorWidth = 640;
    private int mColorHeight = 480;

    private int mDepthHeight = 480;
    private int mDepthWidth = 640;

    short[] mDepthPixel;
    int[] mDepthHist;
//    IntBuffer mDepthBuffer;

    private OpenInterface openInterface;
    private MainHandler mHandler;

    static class MainHandler extends Handler {
        WeakReference<MainActivity_copy> mActivity;

        public MainHandler(MainActivity_copy activity) {
            mActivity = new WeakReference<MainActivity_copy>(activity);
        }

        @Override
        public void handleMessage(Message msg) {
            //每隔1S保存一次
            switch (msg.what) {
                case 1:
                    Utils.getInstance().calculateRunTime();
                    MainActivity_copy mainActivity = mActivity.get();
                    mainActivity.setCalculateRunTimeText(Utils.getInstance().getBuild());
                    mainActivity.calculateCPU();
                    mainActivity.calculateRAM();
                    break;
                default:
                    break;
            }
        }
    }

    public void setCalculateRunTimeText(String result) {
        mTxtRunTime.setText(result);
    }

    public void calculateCPU() {
//        Utils.getInstance().calculateCPU(mTxtCPUMinimum, mTxtCPUHighest,
//                mTxtCPUTotal, mTxtCPUCurrent, mTxtCPUAverage);
    }

    public void calculateRAM() {
//        Utils.getInstance().calculateRAM(mTxtRAMMinimum, mTxtRAMHighest,
//                mTxtRAMCurrent, mTxtRAMAverage);
    }

    private Runnable calculatorRunInfo = new Runnable() {
        @Override
        public void run() {
            Message message = new Message();
            message.what = 1;
            mHandler.sendMessage(message);

            mHandler.removeCallbacks(this);
            mHandler.postDelayed(this, 100);
        }
    };



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        mHandler = new MainHandler(this);
        View decorView = getWindow().getDecorView();
        int uiOptions = View.SYSTEM_UI_FLAG_HIDE_NAVIGATION | View.SYSTEM_UI_FLAG_FULLSCREEN | SYSTEM_UI_FLAG_IMMERSIVE;
        decorView.setSystemUiVisibility(uiOptions);
        initDataView();
        openInterface = new ObViewWallPresentImp(this);
        ((ObViewWallPresentImp) openInterface).setViewCallBack(this);
        ((ObViewWallPresentImp) openInterface).setmGLBodyRenderer(mGLBodyRenderer);
        setCheckBoxChoice();
        //获取权限
        if (Build.VERSION.SDK_INT >= M) {
            if ((ActivityCompat.checkSelfPermission(this, Manifest.permission.CAMERA) | ActivityCompat.checkSelfPermission(this, Manifest.permission.WRITE_EXTERNAL_STORAGE))
                    != PackageManager.PERMISSION_GRANTED) {
                requestPermissions(new String[]{Manifest.permission.WRITE_EXTERNAL_STORAGE, Manifest.permission.CAMERA}, 0);
            } else if (checkPermission()) {
                openInterface.initDevice();
            }
        } else {
            openInterface.initDevice();
        }

        Log.e("NativeUtils", "NativeUtils.ByteBufferCopy() = " + NativeUtils.ByteBufferCopy(null, null, 0));




    }

    private void initDataView() {
        mDepthHist = new int[mDepthWidth * mDepthHeight];
        mDepthPixel = new short[mDepthWidth * mDepthHeight];
//        mDepthBuffer = IntBuffer.allocate(mDepthWidth * mDepthHeight);

        mTxtRunTime = findViewById(R.id.txt_run_time);
        mTxtCPUTotal = findViewById(R.id.txt_cpu_total);
        mTxtCPUCurrent = findViewById(R.id.txt_cpu_current);
        mTxtCPUAverage = findViewById(R.id.txt_cpu_average);
        mTxtCPUMinimum = findViewById(R.id.txt_cpu_minimum);
        mTxtCPUHighest = findViewById(R.id.txt_cpu_highest);
        mTxtRAMCurrent = findViewById(R.id.txt_ram_current);
        mTxtRAMAverage = findViewById(R.id.txt_ram_average);
        mTxtRAMMinimum = findViewById(R.id.txt_ram_minimum);
        mTxtRAMHighest = findViewById(R.id.txt_ram_highest);
        mTxtUpdateDataCurrent = findViewById(R.id.txt_update_data_current);
        mTxtUpdateDataAverage = findViewById(R.id.txt_update_data_average);
        mTxtUpdateDataMinimum = findViewById(R.id.txt_update_data_minimum);
        mTxtUpdateDataHighest = findViewById(R.id.txt_update_data_highest);
        mTxtBKUpdateDataCurrent = findViewById(R.id.txt_bkupdate_data_current);
        mTxtBKUpdateDataAverage = findViewById(R.id.txt_bkupdate_data_average);
        mTxtBKUpdateDataMinimum = findViewById(R.id.txt_bkupdate_data_minimum);
        mTxtBKUpdateDataHighest = findViewById(R.id.txt_bkupdate_data_highest);
        mTxtFRCurrent = findViewById(R.id.txt_frupdate_current);
        mTxtFRAverage = findViewById(R.id.txt_frupdate_average);
        mTxtFRMinimum = findViewById(R.id.txt_frupdate_minimum);
        mTxtFRHighest = findViewById(R.id.txt_frupdate_highest);
        mTxt1 = findViewById(R.id.txtv1);
        mTxt2 = findViewById(R.id.txtv2);
        mTxt3 = findViewById(R.id.txtv3);
        mTxt4 = findViewById(R.id.txtv4);
        mTxt5 = findViewById(R.id.txtv5);
//        mSaveButton   = findViewById(R.id.saveButton);


        //  btn_state();
        initGLView();
        initViewState();


    }

//    /**
//     * 控制按钮状态
//     */
//    @SuppressLint("ClickableViewAccessibility")
//    private void btn_state(){
//
//        btn_depth.setOnTouchListener(new View.OnTouchListener() {
//
//
//            @SuppressLint({"ClickableViewAccessibility", "ResourceAsColor"})
//            @Override
//            public boolean onTouch(View view, MotionEvent motionEvent) {
//
//                boolean checked = btn_depth.isChecked();
//
//                if(motionEvent.getAction() == MotionEvent.ACTION_DOWN){
//
//                    btn_depth.setTextColor(R.color.btn_color);
//
//
//                }else if(motionEvent.getAction() == MotionEvent.ACTION_UP) {
//
//                    btn_depth.setBackgroundColor(Color.BLUE);
//                }
//
//                return false;
//            }
//        });
//    }

    private void initGLView() {
        mColorView = findViewById(R.id.colorview);
        mDepthView = findViewById(R.id.depthview);
        mMaskedColorView = findViewById(R.id.maskcolorview);
        mColorizedBodyView = findViewById(R.id.colorizedbodyview);

        mGLBodyView = findViewById(R.id.skeletonview);
        mGLBodyView.setEGLContextClientVersion(2);
        //设置背景颜色透明
        mGLBodyView.setEGLConfigChooser(8, 8, 8, 8, 16, 0);
        mGLBodyView.getHolder().setFormat(PixelFormat.TRANSLUCENT);
        mGLBodyView.setZOrderOnTop(true);


        mGLBodyRenderer = new GlBodyRenderer(this);
        mGLBodyView.setRenderer(mGLBodyRenderer);
        mGLBodyView.setRenderMode(GLSurfaceView.RENDERMODE_WHEN_DIRTY);
    }

    private void initViewState() {
        mColorView.setVisibility(View.INVISIBLE);
        mDepthView.setVisibility(View.INVISIBLE);
        mGLBodyView.setVisibility(View.INVISIBLE);
        mMaskedColorView.setVisibility(View.INVISIBLE);
        mColorizedBodyView.setVisibility(View.INVISIBLE);
    }

    private void setCheckBoxChoice() {
        mCheckColorBox = findViewById(R.id.bt_color);
        mCheckDepthBox = findViewById(R.id.bt_depth);
        mCheckMaskedColorBox = findViewById(R.id.bt_maskedcolor);
        mCheckColorizedBodyBox = findViewById(R.id.bt_colorizedbody);
        mCheckSkeletonBox = findViewById(R.id.bt_skeleton);
        mCheckColorMirroredBox = findViewById(R.id.bt_iscolormirrored);
        mToggleDepthRes = findViewById(R.id.tb_depthres);
        mCheckIsShowBox = findViewById(R.id.bt_isshow);



        CheckBoxCheckChangeListenter checkBoxCheckChangeListenter = new CheckBoxCheckChangeListenter(openInterface,
                mColorView, mDepthView,
                mMaskedColorView, mColorizedBodyView,
                mGLBodyView,this);
        mCheckColorBox.setOnCheckedChangeListener(checkBoxCheckChangeListenter);
        mCheckDepthBox.setOnCheckedChangeListener(checkBoxCheckChangeListenter);
        mCheckMaskedColorBox.setOnCheckedChangeListener(checkBoxCheckChangeListenter);
        mCheckColorizedBodyBox.setOnCheckedChangeListener(checkBoxCheckChangeListenter);
        mCheckSkeletonBox.setOnCheckedChangeListener(checkBoxCheckChangeListenter);
        mCheckColorMirroredBox.setOnCheckedChangeListener(checkBoxCheckChangeListenter);
        mToggleDepthRes.setOnCheckedChangeListener(checkBoxCheckChangeListenter);
        mCheckIsShowBox.setOnCheckedChangeListener(checkBoxCheckChangeListenter);

    }


    @Override
    protected void onResume() {
        super.onResume();
        mHandler.post(calculatorRunInfo);

    }

    @Override
    protected void onPause() {
        super.onPause();

        mHandler.removeCallbacks(calculatorRunInfo);

    }

    @Override
    protected void onDestroy() {
        //程序退出的时候停止更新数据，检查流是否stop、去掉监听器、釋放设备资源。
        // TODO: 2018/12/25 退出
        openInterface.onRelease();
        super.onDestroy();
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        if (grantResults[0] == PackageManager.PERMISSION_GRANTED) {
            openInterface.initDevice();
        } else {
            Toast.makeText(this, "应用即将在3秒后退出", Toast.LENGTH_LONG).show();
            try {
                Thread.sleep(3000);
                finish();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }

    /* 检查识别有设备使用权限 */
    private boolean checkPermission() {
        return (ActivityCompat.checkSelfPermission(this, Manifest.permission.CAMERA) == PackageManager.PERMISSION_GRANTED &&
                ActivityCompat.checkSelfPermission(this, Manifest.permission.WRITE_EXTERNAL_STORAGE) == PackageManager.PERMISSION_GRANTED);
    }

    @Override
    public void update(final int type, int width, int height, final ByteBuffer buffer) {

        switch (type) {
            case OBSourceInterface.TYPE_COLOR:
                mColorView.update(width, height, buffer);
                break;
            case OBSourceInterface.TYPE_BODY:

                mGLBodyView.requestRender();
                break;
            case OBSourceInterface.TYPE_COLOR_ZEDBODY:
                mColorizedBodyView.update(width, height, buffer);
                break;
            case OBSourceInterface.TYPE_MASKED_COLOR:
                mMaskedColorView.update(width, height, buffer);
                break;
            default:
                break;
        }
    }

    @Override
    public void updateBodyData(final int index, final Vector2D pos, final int depth) {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                switch (index) {
                    case -1:
                        mTxt1.setVisibility(View.GONE);
                        mTxt1.setText("");
                        mTxt2.setVisibility(View.GONE);
                        mTxt2.setText("");
                        mTxt3.setVisibility(View.GONE);
                        mTxt3.setText("");
                        mTxt4.setVisibility(View.GONE);
                        mTxt4.setText("");
                        mTxt5.setVisibility(View.GONE);
                        mTxt5.setText("");
                        break;
                    case 0:
                        mTxt1.setVisibility(View.VISIBLE);
                        mTxt1.setText(depth + " mm");
                        mTxt1.setX(pos.getX() - mTxt1.getWidth() / 2f);
                        mTxt1.setY(pos.getY());
                        mTxt2.setVisibility(View.GONE);
                        mTxt2.setText("");
                        mTxt3.setVisibility(View.GONE);
                        mTxt3.setText("");
                        mTxt4.setVisibility(View.GONE);
                        mTxt4.setText("");
                        mTxt5.setVisibility(View.GONE);
                        mTxt5.setText("");
                        break;

                    case 1:
                        mTxt2.setVisibility(View.VISIBLE);
                        mTxt2.setText(depth + " mm");
                        mTxt2.setX(pos.getX() - mTxt1.getWidth() / 2f);
                        mTxt2.setY(pos.getY());
                        break;

                    case 2:
                        mTxt3.setVisibility(View.VISIBLE);
                        mTxt3.setText(depth + " mm");
                        mTxt3.setX(pos.getX() - mTxt2.getWidth() / 2f);
                        mTxt3.setY(pos.getY());
                        break;

                    case 3:
                        mTxt4.setVisibility(View.VISIBLE);
                        mTxt4.setText(depth + " mm");
                        mTxt4.setX(pos.getX() - mTxt3.getWidth() / 2f);
                        mTxt4.setY(pos.getY());
                        break;

                    case 4:
                        mTxt5.setVisibility(View.VISIBLE);
                        mTxt5.setText(depth + " mm");
                        mTxt5.setX(pos.getX() - mTxt4.getWidth() / 2f);
                        mTxt5.setY(pos.getY());
                        break;
                }
            }
        });

    }

    @Override
    public void updateDepth(int width, int height, ShortBuffer depthData) {
//        runOnUiThread(new Runnable() {
//            @Override
//            public void run() {
//            }
//        });

        if (mDepthPixel.length != width * height) {
            mDepthPixel = new short[width * height];
        }
        depthData.get(mDepthPixel);
        int index = 0;

        for (int y = 0; y < height; y++) {
            for (int x = 0; x < width; x++) {
                int depth = mDepthPixel[width * y + x];

                mDepthHist[index] = 0xff000000 |
                        (depth * 255 / 8000) << 16 |
                        (depth * 255 / 8000) << 8 |
                        (depth * 255 / 8000);
                index++;
            }
        }

//        mDepthBuffer.clear();
//        mDepthBuffer.put(mDepthHist);
        IntBuffer mDepthBuffer = IntBuffer.wrap(mDepthHist);
        mDepthView.fillTexture(width,height,mDepthBuffer);

//        mDepthView.update(mDepthWidth, mDepthHeight, depthData);
    }

    @Override
    public void calculateUpdateData(FPSMeter colorMeter) {
        Utils.getInstance().calculateUpdateData(colorMeter, mTxtUpdateDataCurrent,
                mTxtUpdateDataAverage, mTxtUpdateDataMinimum,
                mTxtUpdateDataHighest, mTxtBKUpdateDataCurrent,
                mTxtBKUpdateDataAverage, mTxtBKUpdateDataMinimum,
                mTxtBKUpdateDataHighest);
    }

    @Override
    public void calculateShowTime() {
//        Utils.getInstance().calculateShowTime(mColorView, mDepthView,
//                mMaskedColorView, mColorizedBodyView,
//                mGLBodyRenderer, mTxtFRCurrent,
//                mTxtFRAverage, mTxtFRMinimum,
//                mTxtFRHighest);
    }

    @Override
    public void isCameraOpen() {

    }

    @Override
    public void CameraOpenFailed() {

    }

    @Override
    public void onNoDevice() {

    }

    @Override
    public void isExistsColorCamera(int pid) {

    }

}


