package com.orbbec.obviewer2.listener;

import android.hardware.usb.UsbDevice;
import android.util.Log;

import com.orbbec.astra.android.AstraDeviceManagerListener;
import com.orbbec.obviewer2.present.OpenInterface;

/**
 * @author tanzhuohui
 * @date 2018/12/25
 */
public class OBAstraDeviceManagerListener implements AstraDeviceManagerListener {
    private final static String TAG = "AstraDManagerListener";
    private OpenInterface openInterface;

    public OBAstraDeviceManagerListener(OpenInterface openInterface) {
        this.openInterface = openInterface;
    }

    @Override
    public void onOpenAllDevicesCompleted(Iterable<UsbDevice> iterable) {

        Log.d(TAG, "onOpenAllDevicesCompleted");
        openInterface.onDeviceOpened();
    }

    @Override
    public void onOpenDeviceCompleted(UsbDevice usbDevice, boolean b) {
        Log.d(TAG, "onOpenDeviceCompleted");
        if (!b) {
            openInterface.onDeviceFailed();
        }
    }

    @Override
    public void onNoDevice() {
        Log.d(TAG, "onNoDevice: ");
        openInterface.onNoDevice();
    }

    @Override
    public void onPermissionDenied(UsbDevice usbDevice) {
        Log.d(TAG, "onPermissionDenied: ");
    }
}
