package com.orbbec.obviewer2.model;

import android.content.Context;

import com.orbbec.astra.BodyFrame;
import com.orbbec.astra.BodyTrackingFeatureFlags;
import com.orbbec.astra.DepthFrame;
import com.orbbec.astra.ImageFrame;
import com.orbbec.astra.SkeletonProfile;


/**
 * @author tanzhuohui
 * @date 2018/12/25
 */
public interface OBSourceInterface {

    int TYPE_COLOR = 1;
    int TYPE_DEPTH = 2;
    int TYPE_BODY = 4;
    int TYPE_MASKED_COLOR = 8;
    int TYPE_COLOR_ZEDBODY = 16;
    int TYPE_SHOW_STREAM = 32;

    void initDevice(Context context);
    void onDeviceOpened();
    Object getStream(int type);
    void startStream(int type);
    void stopStream(int type);
    void setResolution(int type, int width, int height);
    void setMirror(int type, boolean isMirror);
    void onRelease();
    void onImageFrame(int type , ImageFrame imageFrame , boolean hasUser);
    void onBodyFrame(int type , BodyFrame imageFrame , boolean hasUser);
    void onBodyAndDepthFrame(int type , BodyFrame bodyFrame , DepthFrame imageFrame , boolean hasUser);

    void setSkeletonProfile(SkeletonProfile profile);
    void setDefaultBodyFeatures( BodyTrackingFeatureFlags features);
}
