package com.orbbec.obviewer2.present;

import com.orbbec.astra.BodyFrame;
import com.orbbec.astra.BodyTrackingFeatureFlags;
import com.orbbec.astra.DepthFrame;
import com.orbbec.astra.ImageFrame;
import com.orbbec.astra.SkeletonProfile;
import com.orbbec.obviewer2.util.FPSMeter;

/**
 * @author tanzhuohui
 * @date 2018/12/25
 */
public interface OpenInterface {
    void initDevice();

    void onDeviceOpened();

    void onDeviceFailed();

    Object getStream(int type);

    void startStream(int type);

    void stopStream(int type);

    void setResolution(int type, int width, int height);

    void setMirror(int type, boolean isMirror);

    void onRelease();

    void addType(int type);

    void cutType(int type);

    void onImageFrame(int type, ImageFrame imageFrame, boolean hasUser);

    void onBodyFrame(int type, BodyFrame imageFrame, boolean hasUser);

    void onBodyAndDepthFrame(int type, BodyFrame bodyFrame, DepthFrame imageFrame, boolean hasUser);

    void calculateUpdateData(FPSMeter colorMeter);

    //前台显示时间
    void calculateShowTime();

    void setSkeletonProfile(SkeletonProfile profile);

    void setDefaultBodyFeatures(BodyTrackingFeatureFlags features);

    void onNoDevice();

    void isExistsColorCamera(int pid);


}
