package com.orbbec.obviewer2.util;

import java.util.Arrays;

public class Color {
    private final float[] mComponents;

    public Color() {
        // This constructor is required for compatibility with previous APIs
        mComponents = new float[]{0.0f, 0.0f, 0.0f, 1.0f};
    }

    private Color(float r, float g, float b, float a) {
        mComponents = new float[] { r, g, b, a };
    }

    public static Color valueOf(float r, float g, float b) {
        return new Color(r, g, b, 1.0f);
    }

    public static Color valueOf(float r, float g, float b, float a) {
        return new Color(saturate(r), saturate(g), saturate(b), saturate(a));
    }

    private static float saturate(float v) {
        return v <= 0.0f ? 0.0f : (v >= 1.0f ? 1.0f : v);
    }

    public float[] getComponents() {
        return Arrays.copyOf(mComponents, mComponents.length);
    }
}
