package com.orbbec.obviewer2.util;

import java.text.DecimalFormat;
import java.text.NumberFormat;

public class FPSMeter {
    private long mPrevTS;
    private float mFPS;
    private long mPassTime;
    private int mN;
    private int mCount;

    DecimalFormat mdt;
    private int mFrameCount = -1;
    private long mLastTime;
    private float mFps = -1;
    public FPSMeter() {
        mCount = 1;
        mdt = (DecimalFormat) NumberFormat.getInstance(); //获得格式化类对象
        mdt.applyPattern("0.0");
    }

    public void mesureFps(){
        long now = System.nanoTime();
        if (mFrameCount < 0){
            mFrameCount = 0;
            mLastTime = now;
        }
        ++mFrameCount;
        if (mFrameCount == 30) {
            long diff = now - mLastTime;
            mFps = (float) (1e9 * 30 / diff * 1.0f);
            mFrameCount = 0;
            mLastTime = now;
        }
        return ;
    }

    public float getFps() {
        return mFps;
    }

    public String getFpsString() {
        return mdt.format(mFps);
    }

    private void reset() {
        mPassTime = 0;
        mCount = 0;
    }
}
