package com.orbbec.obviewer2.util;

import android.content.Context;
import android.util.Log;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.orbbec.obviewer2.R;

import static com.orbbec.obviewer2.MainActivity.TAG;

public class IToast {

    public static void show(Context context) {
        show(context,  Toast.LENGTH_SHORT);
    }

    private static void show(Context context, int show_length) {
        //   Context context = Application.getGlobalContext();
        //使用布局加载器，将编写的toast_layout布局加载进来
        View view = LayoutInflater.from(context).inflate(R.layout.layout_toast, null);
        //获取ImageView
        ImageView image = (ImageView) view.findViewById(R.id.toast_iv);
        //设置图片
        image.setImageResource(R.mipmap.hook);
        //获取TextView
        TextView title = (TextView) view.findViewById(R.id.toast_text);
        //设置显示的内容
       // title.setText(massage);
        Toast toast = new Toast(context);
        //设置Toast要显示的位置，水平居中并在底部，X轴偏移0个单位，Y轴偏移70个单位，
        toast.setGravity(Gravity.CENTER_HORIZONTAL | Gravity.BOTTOM, 0, 70);
        //设置显示时间
        toast.setDuration(show_length);
        Log.d(TAG, "show:执行 ");

        toast.setView(view);
        toast.show();
    }
}
