package com.orbbec.obviewer2.view;

import android.content.Context;
import android.opengl.GLSurfaceView;
import android.util.Log;

import com.orbbec.obviewer2.util.Circle;

import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

import static android.opengl.GLES10.glClearColor;
import static android.opengl.GLES20.GL_COLOR_BUFFER_BIT;
import static android.opengl.GLES20.glClear;
import static android.opengl.GLES20.glViewport;

public class MyRender implements GLSurfaceView.Renderer {

    private Context context;

    public MyRender(Context context){
        this.context = context;
    }


    Circle circle;

    public void onSurfaceCreated(GL10 gl, EGLConfig config) {
        Log.w("MyRender","onSurfaceCreated");
        glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
        circle = new Circle(context);
    }

    public void onSurfaceChanged(GL10 gl, int width, int height) {
        Log.w("MyRender","onSurfaceChanged");
        glViewport(0,0,width,height);
        //设置投影矩阵
        circle.projectionMatrix(width, height);
    }

    public void onDrawFrame(GL10 gl) {
        Log.w("MyRender","onDrawFrame");
        glClear(GL_COLOR_BUFFER_BIT);
        circle.draw();
    }


}
