package com.orbbec.obviewer2.view;

import android.content.Context;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Rect;
import android.util.AttributeSet;
import android.util.Log;
import android.widget.ToggleButton;

import static com.orbbec.obviewer2.MainActivity.TAG;

public class MyToggleButton extends ToggleButton {
    public MyToggleButton(Context context) {
        super(context);
    }

    public MyToggleButton(Context context, AttributeSet attrs) {
        super(context, attrs);
    }

    public MyToggleButton(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
    }

    private boolean focused;


    @Override
    public void addOnLayoutChangeListener(OnLayoutChangeListener listener) {
        super.addOnLayoutChangeListener(listener);

        int w = this.getWidth();
        int h = this.getHeight();
        Log.d(TAG, "addOnLayoutChangeListener: "+w);
    }

    @Override
    protected void onFocusChanged(boolean focused, int direction, Rect previouslyFocusedRect) {
        super.onFocusChanged(focused, direction, previouslyFocusedRect);

        this.focused = focused;
        if (focused) {

            android.view.ViewGroup.LayoutParams temp = this.getLayoutParams();
            temp.height = this.getHeight() - 1;
            temp.width = this.getWidth() - 1;
            Log.d(TAG, "onFocusChanged: "+this.getHeight()+ " : "+this.getWidth());
            this.setLayoutParams(temp);
        } else {
            android.view.ViewGroup.LayoutParams temp = this.getLayoutParams();
            temp.height = this.getHeight() + 1;
            temp.width = this.getWidth() + 1;
            this.setLayoutParams(temp);
        }
    }



    @Override
    protected void onDraw(android.graphics.Canvas canvas) {
        //this.getba
        if (focused) {
            Paint paint = new Paint();
            paint.setColor(Color.argb(236, 246, 254, 1));
            paint.setStrokeWidth(4);
            canvas.drawLine(1, 1, this.getWidth() - 1, 1, paint);
            canvas.drawLine(1, 1, 1, this.getHeight() - 1, paint);
            canvas.drawLine(1, this.getHeight() - 1, this.getWidth() - 1, this.getHeight() - 1, paint);
            canvas.drawLine(this.getWidth() - 1, 1, this.getWidth() - 1, this.getHeight() - 1, paint);

        }

        super.onDraw(canvas);
    }


}
